<template>
  <v-container>
    <v-row>
      <v-col cols="5">
        </v-col>
        <v-col cols="7">
            <h1>Log Data</h1>
        </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
         <v-data-table
            :headers="headers"
            :items="logs"
            :search="search"
            :custom-filter="doSearch"
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
           <template v-slot:[`item.message`]="{ item }">
             <v-icon small class="mr-2" @click="doCheckDetail(item)">mdi-file-find</v-icon>
             {{ item.message }}
           </template>
        </v-data-table>
      </v-col>
    </v-row>
    <LogDataDetail ref="dlg" />
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import service from "../service/LogDataService";
import LogDataDetail from "../components/LogDataDetail";

export default {
  name:'LogData',
  components: {
    LogDataDetail,
    DlgMsg,
    Loading,
  },
  data:function() {
    return {
      expanded: [],
      singleExpand: true,
      search: '',
      logs: [],
      logsDetail: [],
      title: null,
      headers:[
        {text: "No.", align: "start", value: "number", sortable: true},
        {text: "MESSAGE", align: "start", value: "message", sortable: false},
        {text: "OPERATION", align: "start", value: "operation", sortable: true},
        {text: "TABLE", align: "start", value: "tbname", sortable: true},
        {text: "TABLE KEY", align: "start", value: "tbkey", sortable: true},
        {text: "IP CLIENT", align: "start", value: "ip_client", sortable: true},
        {text: "USERNAME", align: "start", value: "username", sortable: true},
        {text: "CREATE AT", align: "start", value: "create_at", sortable: true},
      ],
      dialogAdd: false,
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    async doRefresh(){
      this.statusProgress = true
      await service.getAll()
        .then(res => {
          this.logs = res.data.data
          let number = 1
          for (let logs of this.logs) {
            logs.number = `${number++}.`
          }
        })
        .catch(err => {
          console.log(err)
          console.log(err.response)
        })
      this.statusProgress = false
    },
    doCheckDetail(logs) {
      let title = `${logs.tbname.toUpperCase()} - ${logs.tbkey.toUpperCase()}`
      this.$refs.dlg.doShow(logs.log_details, title, true)
    },
  },
  mounted() {
    this.doRefresh()
  }
}
</script>